; Script para probar la triple inversin
(defun properp (x)
  (if (consp x)
      (properp (cdr x))
    (equal x nil)))

(defun app (a b)
  (if (consp a)
      (cons (car a) (app (cdr a) b))
    b))

(defun rev (x)
  (if (consp x)
      (app (rev (cdr x)) (cons (car x) nil))
    nil))

(defthm properp-app
  (equal (properp (app a b))
 	 (properp b)))
(defthm app-right-identity
  (implies (properp x)
	   (equal (app x nil) x)))
 (defthm properp-rev
   (properp (rev x)))
 (defthm app-assoc
   (equal (app (app a b) c)
 	 (app a (app b c))))
 (defthm rev-app
   (equal (rev (app a b))
 	 (app (rev b) (rev a))))
 (defthm rev-rev
   (implies (properp x)
 	   (equal (rev (rev z)) z)))
 (defthm triple-rev
   (equal (rev (rev (rev a))) (rev a)))